Add support for providing and autocopying Sources files along the way
[ntk/apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 # we all like colorful messages
4 CERROR="\e[1;31m" # red
5 CWARNING="\e[1;33m" # yellow
6 CMSG="\e[1;32m" # green
7 CINFO="\e[1;96m" # light blue
8 CDEBUG="\e[1;94m" # blue
9 CNORMAL="\e[0;39m" # default system console color
10 CDONE="\e[1;32m" # green
11 CPASS="\e[1;32m" # green
12 CFAIL="\e[1;31m" # red
13 CCMD="\e[1;35m" # pink
14
15 msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30 # enable / disable Debugging
31 MSGLEVEL=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34 fi
35 if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38 fi
39 if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
42 fi
43 if [ $MSGLEVEL -le 3 ]; then
44 msginfo() { true; }
45 msgninfo() { true; }
46 fi
47 if [ $MSGLEVEL -le 4 ]; then
48 msgdebug() { true; }
49 msgndebug() { true; }
50 fi
51 msgdone() {
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
57 true;
58 else
59 echo "${CDONE}DONE${CNORMAL}" >&2;
60 fi
61 }
62
63 runapt() {
64 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
65 if [ -f ./aptconfig.conf ]; then
66 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
67 elif [ -f ../aptconfig.conf ]; then
68 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
69 else
70 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
71 fi
72 }
73 aptconfig() { runapt apt-config $*; }
74 aptcache() { runapt apt-cache $*; }
75 aptget() { runapt apt-get $*; }
76 aptftparchive() { runapt apt-ftparchive $*; }
77 aptkey() { runapt apt-key $*; }
78 dpkg() {
79 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
80 }
81 aptitude() {
82 if [ -f ./aptconfig.conf ]; then
83 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
84 elif [ -f ../aptconfig.conf ]; then
85 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
86 else
87 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
88 fi
89 }
90
91 setupenvironment() {
92 TMPWORKINGDIRECTORY=$(mktemp -d)
93 local TESTDIR=$(readlink -f $(dirname $0))
94 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
95 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
96 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
97 local OLDWORKINGDIRECTORY=$(pwd)
98 CURRENTTRAP="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
99 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
100 cd $TMPWORKINGDIRECTORY
101 mkdir rootdir aptarchive keys
102 cd rootdir
103 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
104 mkdir -p var/cache var/lib var/log
105 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
106 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
107 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
108 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
109 else
110 touch var/lib/dpkg/status
111 fi
112 touch var/lib/dpkg/available
113 mkdir -p usr/lib/apt
114 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
115 cd ..
116 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
117 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
118 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
119 else
120 touch aptarchive/Packages
121 fi
122 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
123 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
124 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
125 else
126 touch aptarchive/Sources
127 fi
128 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
129 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
130 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
131 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
132 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
133 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
134 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
135 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
136 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
137 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
138 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
139 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
140 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
141 export LC_ALL=C
142 msgdone "info"
143 }
144
145 configarchitecture() {
146 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
147 echo "APT::Architecture \"$1\";" > $CONFFILE
148 shift
149 while [ -n "$1" ]; do
150 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
151 shift
152 done
153 }
154
155 setupsimplenativepackage() {
156 local NAME="$1"
157 local ARCH="$2"
158 local VERSION="$3"
159 local RELEASE="${4:-unstable}"
160 local DEPENDENCIES="$5"
161 local DESCRIPTION="$6"
162 local SECTION="${7:-others}"
163 local DISTSECTION
164 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
165 DISTSECTION="main"
166 else
167 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
168 fi
169 local BUILDDIR=incoming/${NAME}-${VERSION}
170 mkdir -p ${BUILDDIR}/debian/source
171 cd ${BUILDDIR}
172 echo "* most suckless software product ever" > FEATURES
173 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
174 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
175
176 * Initial release
177
178 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
179 test -e debian/control || echo "Source: $NAME
180 Section: $SECTION
181 Priority: optional
182 Maintainer: Joe Sixpack <joe@example.org>
183 Build-Depends: debhelper (>= 7)
184 Standards-Version: 3.9.1
185
186 Package: $NAME
187 Architecture: $ARCH" > debian/control
188 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
189 if [ -z "$DESCRIPTION" ]; then
190 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
191 If you find such a package installed on your system,
192 YOU did something horribly wrong! They are autogenerated
193 und used only by testcases for APT and surf no other propose…" >> debian/control
194 else
195 echo "Description: $DESCRIPTION" >> debian/control
196 fi
197 test -e debian/compat || echo "7" > debian/compat
198 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
199 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
200 cd - > /dev/null
201 }
202
203 buildsimplenativepackage() {
204 local NAME="$1"
205 local ARCH="$2"
206 local VERSION="$3"
207 local RELEASE="${4:-unstable}"
208 local DEPENDENCIES="$5"
209 local DESCRIPTION="$6"
210 local SECTION="${7:-others}"
211 local DISTSECTION
212 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
213 DISTSECTION="main"
214 else
215 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
216 fi
217 setupsimplenativepackage "$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
218 buildpackage "incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
219 rm -rf "incoming/${NAME}-${VERSION}"
220 }
221
222 buildpackage() {
223 local BUILDDIR=$1
224 local RELEASE=$2
225 local SECTION=$3
226 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
227 cd $BUILDDIR
228 if [ "$ARCH" = "all" ]; then
229 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
230 fi
231 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
232 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
233 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
234 cd - > /dev/null
235 for PKG in $PKGS; do
236 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
237 done
238 for SRC in $SRCS; do
239 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
240 done
241 msgdone "info"
242 }
243
244 buildaptarchive() {
245 if [ -d incoming ]; then
246 buildaptarchivefromincoming $*
247 else
248 buildaptarchivefromfiles $*
249 fi
250 }
251
252 createaptftparchiveconfig() {
253 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
254 if [ -z "$ARCHS" ]; then
255 # the pool is empty, so we will operate on faked packages - let us use the configured archs
256 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
257 fi
258 echo -n 'Dir {
259 ArchiveDir "' >> ftparchive.conf
260 echo -n $(readlink -f .) >> ftparchive.conf
261 echo -n '";
262 CacheDir "' >> ftparchive.conf
263 echo -n $(readlink -f ..) >> ftparchive.conf
264 echo -n '";
265 FileListDir "' >> ftparchive.conf
266 echo -n $(readlink -f pool/) >> ftparchive.conf
267 echo -n '";
268 };
269 Default {
270 Packages::Compress ". gzip bzip2 lzma";
271 Sources::Compress ". gzip bzip2 lzma";
272 Contents::Compress ". gzip bzip2 lzma";
273 };
274 TreeDefault {
275 Directory "pool/";
276 SrcDirectory "pool/";
277 };
278 APT {
279 FTPArchive {
280 Release {
281 Origin "joesixpack";
282 Label "apttestcases";
283 Suite "unstable";
284 Description "repository with dummy packages";
285 Architectures "' >> ftparchive.conf
286 echo -n "$ARCHS" >> ftparchive.conf
287 echo 'source";
288 };
289 };
290 };' >> ftparchive.conf
291 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
292 echo -n 'tree "dists/' >> ftparchive.conf
293 echo -n "$DIST" >> ftparchive.conf
294 echo -n '" {
295 Architectures "' >> ftparchive.conf
296 echo -n "$ARCHS" >> ftparchive.conf
297 echo -n 'source";
298 FileList "' >> ftparchive.conf
299 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
300 echo -n '";
301 SourceFileList "' >> ftparchive.conf
302 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
303 echo -n '";
304 Sections "' >> ftparchive.conf
305 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
306 echo '";
307 };' >> ftparchive.conf
308 done
309 }
310
311 buildaptftparchivedirectorystructure() {
312 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
313 for DIST in $DISTS; do
314 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
315 for SECTION in $SECTIONS; do
316 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
317 for ARCH in $ARCHS; do
318 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
319 done
320 mkdir -p dists/${DIST}/${SECTION}/source
321 mkdir -p dists/${DIST}/${SECTION}/i18n
322 done
323 done
324 }
325
326 insertpackage() {
327 local RELEASE="$1"
328 local NAME="$2"
329 local ARCH="$3"
330 local VERSION="$4"
331 local DEPENDENCIES="$5"
332 local ARCHS="$ARCH"
333 if [ "$ARCHS" = "all" ]; then
334 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
335 fi
336 for BUILDARCH in $ARCHS; do
337 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
338 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
339 touch aptarchive/dists/${RELEASE}/main/source/Sources
340 local FILE="${PPATH}/Packages"
341 echo "Package: $NAME
342 Priority: optional
343 Section: other
344 Installed-Size: 23356
345 Maintainer: Joe Sixpack <joe@example.org>
346 Architecture: $ARCH
347 Version: $VERSION" >> $FILE
348 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
349 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
350 If you find such a package installed on your system,
351 YOU did something horribly wrong! They are autogenerated
352 und used only by testcases for APT and surf no other propose…
353 " >> $FILE
354 done
355 }
356
357 buildaptarchivefromincoming() {
358 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
359 cd aptarchive
360 [ -e pool ] || ln -s ../incoming pool
361 [ -e ftparchive.conf ] || createaptftparchiveconfig
362 [ -e dists ] || buildaptftparchivedirectorystructure
363 msgninfo "\tGenerate Packages, Sources and Contents files… "
364 aptftparchive -qq generate ftparchive.conf
365 cd - > /dev/null
366 msgdone "info"
367 generatereleasefiles
368 }
369
370 buildaptarchivefromfiles() {
371 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
372 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
373 msgninfo "\t${line} file… "
374 cat ${line} | gzip > ${line}.gz
375 cat ${line} | bzip2 > ${line}.bz2
376 cat ${line} | lzma > ${line}.lzma
377 msgdone "info"
378 done
379 generatereleasefiles
380 }
381
382 generatereleasefiles() {
383 msgninfo "\tGenerate Release files… "
384 if [ -e aptarchive/dists ]; then
385 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
386 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
387 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
388 if [ "$CODENAME" = "experimental" ]; then
389 sed -i '/^Date: / a\
390 NotAutomatic: yes' $dir/Release
391 fi
392 done
393 else
394 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
395 fi
396 msgdone "info"
397 }
398
399 setupdistsaptarchive() {
400 local APTARCHIVE=$(readlink -f ./aptarchive)
401 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
402 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
403 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
404 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
405 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
406 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
407 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
408 msgdone "info"
409 done
410 }
411
412 setupflataptarchive() {
413 local APTARCHIVE=$(readlink -f ./aptarchive)
414 if [ -f ${APTARCHIVE}/Packages ]; then
415 msgninfo "\tadd deb sources.list line… "
416 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
417 msgdone "info"
418 else
419 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
420 fi
421 if [ -f ${APTARCHIVE}/Sources ]; then
422 msgninfo "\tadd deb-src sources.list line… "
423 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
424 msgdone "info"
425 else
426 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
427 fi
428 }
429
430 setupaptarchive() {
431 buildaptarchive
432 if [ -e aptarchive/dists ]; then
433 setupdistsaptarchive
434 else
435 setupflataptarchive
436 fi
437 signreleasefiles
438 msgninfo "\tSync APT's cache with the archive… "
439 aptget update -qq
440 msgdone "info"
441 }
442
443 signreleasefiles() {
444 local SIGNER="${1:-Joe Sixpack}"
445 msgninfo "\tSign archive with $SIGNER key… "
446 local SECKEYS=""
447 for KEY in $(find keys/ -name '*.sec'); do
448 SECKEYS="$SECKEYS --secret-keyring $KEY"
449 done
450 local PUBKEYS=""
451 for KEY in $(find keys/ -name '*.pub'); do
452 PUBKEYS="$PUBKEYS --keyring $KEY"
453 done
454 for RELEASE in $(find aptarchive/ -name Release); do
455 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
456 done
457 msgdone "info"
458 }
459
460 changetowebserver() {
461 if which weborf > /dev/null; then
462 weborf -xb aptarchive/ 2>&1 > /dev/null &
463 CURRENTTRAP="kill $!; $CURRENTTRAP"
464 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
465 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
466 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
467 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
468 done
469 return 0
470 fi
471 return 1
472 }
473
474 checkdiff() {
475 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
476 if [ -n "$DIFFTEXT" ]; then
477 echo
478 echo "$DIFFTEXT"
479 return 1
480 else
481 return 0
482 fi
483 }
484
485 testfileequal() {
486 local FILE="$1"
487 shift
488 msgtest "Test for correctness of file" "$FILE"
489 if [ -z "$*" ]; then
490 echo -n "" | checkdiff $FILE - && msgpass || msgfail
491 else
492 echo "$*" | checkdiff $FILE - && msgpass || msgfail
493 fi
494 }
495
496 testequal() {
497 local COMPAREFILE=$(mktemp)
498 echo "$1" > $COMPAREFILE
499 shift
500 msgtest "Test for equality of" "$*"
501 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
502 rm $COMPAREFILE
503 }
504
505 testequalor2() {
506 local COMPAREFILE1=$(mktemp)
507 local COMPAREFILE2=$(mktemp)
508 local COMPAREAGAINST=$(mktemp)
509 echo "$1" > $COMPAREFILE1
510 echo "$2" > $COMPAREFILE2
511 shift 2
512 msgtest "Test for equality OR of" "$*"
513 $* 2>&1 1> $COMPAREAGAINST
514 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
515 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
516 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
517 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
518 msgfail )
519 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
520 }
521
522 testshowvirtual() {
523 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
524 local PACKAGE="$1"
525 shift
526 while [ -n "$1" ]; do
527 VIRTUAL="${VIRTUAL}
528 N: Can't select versions from package '$1' as it purely virtual"
529 PACKAGE="${PACKAGE} $1"
530 shift
531 done
532 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
533 VIRTUAL="${VIRTUAL}
534 N: No packages found"
535 local COMPAREFILE=$(mktemp)
536 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
537 eval `apt-config shell ARCH APT::Architecture`
538 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
539 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
540 rm $COMPAREFILE
541 }
542
543 testnopackage() {
544 msgtest "Test for non-existent packages" "apt-cache show $*"
545 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
546 if [ -n "$SHOWPKG" ]; then
547 echo
548 echo "$SHOWPKG"
549 msgfail
550 return 1
551 fi
552 msgpass
553 }
554
555 testdpkginstalled() {
556 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
557 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
558 if [ "$PKGS" != 0 ]; then
559 echo $PKGS
560 dpkg -l $* | grep '^[a-z]'
561 msgfail
562 return 1
563 fi
564 msgpass
565 }
566
567 testdpkgnoninstalled() {
568 msgtest "Test for correctly non-installed package(s) with" "dpkg -l $*"
569 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
570 if [ "$PKGS" != 0 ]; then
571 echo
572 dpkg -l $* | grep '^[a-z]'
573 msgfail
574 return 1
575 fi
576 msgpass
577 }